Dev::HookInfo@ g_hookSceneFxUpdate;
array<Input@> Inputs; //This is the list where all our inputs are stored
string FileName = "ReplayName"; //Filename for replay

class Input{
	float gas;
	float brake;
	float steer;
	float time;

	Input(float time, float gas, float brake, float steer)
	{
		this.time = time;
		this.gas = gas;
		this.brake = brake;
		this.steer = steer;
	}
} //This class is created so it's easier to store all our input and when they are pressed in a function

void OnDestroyed()
{
    if (g_hookSceneFxUpdate !is null) {
        Dev::Unhook(g_hookSceneFxUpdate);//Just so the game don't fuck up
    }
}

void Main()
{
	//this is where in binary where Scene is updated in MT
   auto pfSceneFxUpdate = Dev::FindPattern("48 8B C4 55 53 57 41 54 41 55 41 56 48 8D A8 C8 FE FF FF 48 81 EC 08 02 00 00 0F 29 70 B8 0F 29 78 A8 48 8B ?? ?? ?? ?? ?? 48 33 C4 48 89 85");
   if (pfSceneFxUpdate != 0) {
        @g_hookSceneFxUpdate = Dev::Hook(pfSceneFxUpdate, 0, "SceneFxUpdate"); //Means that if the game go through Scene update, it'll call SceneFxUpdate Function
    }
}

void SceneFxUpdate(uint64 r12)
{
	auto app = GetApp();

	auto sceneVis = app.GameScene;
	if (sceneVis is null) {
		return;
	}

	auto Editor = cast<CGameEditorMediaTracker@>(app.Editor);
	if(Editor is null)
		return;

	auto PluginAPI = cast<CGameEditorMediaTrackerPluginAPI@>(Editor.PluginAPI);
	if(PluginAPI is null)
		return;

	if(Inputs.Length > 1) 
		if(PluginAPI.CurrentTimer < Inputs[Inputs.Length-1].time) //Here, if the last input has a greater time that the current timer, it means that the timeline has been restarted so it clear recorded inputs
			Inputs = {};

	//all from Dashboard
	CSceneVehicleVis@ vis = null;

	CSmPlayer@ player = GetViewingPlayer(); //Get the current player (in MT)

	if (player !is null) {
		@vis = Vehicle::GetVis(sceneVis, player);
	} else {
		@vis = Vehicle::GetSingularVis(sceneVis);
	}

	if (vis is null) {
		return;
	}    

	float brake = vis.AsyncState.InputBrakePedal;
	if(vis.AsyncState.InputIsBraking)
		brake = 1.0;

	if(Inputs.Length > 1)
	{
		if(PluginAPI.CurrentTimer != Inputs[Inputs.Length-1].time)//Stop recording if the last input has the same time as current timer, means it's paused
			Inputs.InsertLast(
				Input(
					PluginAPI.CurrentTimer, 
					vis.AsyncState.InputGasPedal, 
					brake, 
					vis.AsyncState.InputSteer
					)
				);//this create a object with those 4 information (see the constructor line 16) and pu it at the end of our list, that's how it record
	} else Inputs.InsertLast(
		Input(
			PluginAPI.CurrentTimer,
			vis.AsyncState.InputGasPedal, 
			brake, 
			vis.AsyncState.InputSteer
			)
		); //this create a object with those 4 information (see the constructor line 16) and pu it at the end of our list, that's how it record
}

CSmPlayer@ GetViewingPlayer() //Function from Dashboard
{
	auto playground = GetApp().CurrentPlayground;
	if (playground is null || playground.GameTerminals.Length != 1) {
		return null;
	}
	return cast<CSmPlayer>(playground.GameTerminals[0].GUIPlayer);
}

void RenderInterface()
{
	UI::Begin("Yes"); //This UI will show last ten inputs from Inputs list

	if(Inputs.Length < 10)
	{
		for(uint i = 0; i < Inputs.Length; i++)
		{
			UI::Text("<"+Inputs[i].gas+ " " + Inputs[i].brake + " " + Inputs[i].steer + ">");
		}
	}
	else 
	{
		for(uint i = Inputs.Length-11; i < Inputs.Length; i++)// minus eleven because last index is list.Length - 1
		{
			UI::Text("<"+Inputs[i].time + " "+ Math::Ceil(Inputs[i].gas)+ " " + Math::Ceil(Inputs[i].brake) + " " + Inputs[i].steer + ">");//Here is how we access all of the inputs information
		}
	}
	FileName = UI::InputText("", FileName);
	if(UI::Button("Save Inputs"))
	{
		if(FileName != "")
			Save_Inputs();// Called when the button is pressed
	}

	UI::End();
}

void Save_Inputs()
{
	string File_To_Load = IO::FromDataFolder("Scripts/" + FileName + ".txt");
	IO::File file(File_To_Load);
	file.Open(IO::FileMode::Write);

	float[] lasts = {0.0,0.0,0.0};

	string str = "";
	for(uint i = 0; i < Inputs.Length; i++)
	{
		if(lasts[0] != Inputs[i].gas)
		{
			lasts[0] = Inputs[i].gas;
			str += int(Inputs[i].time*1000) + " AccelerateReal " + Inputs[i].gas + "\n";
		}

		if(lasts[1] != Inputs[i].brake)
		{
			lasts[1] = Inputs[i].brake;
			str += int(Inputs[i].time*1000) + " BrakeReal " + Inputs[i].brake + "\n";
		}

		if(lasts[2] != Inputs[i].steer)
		{
			lasts[2] = Inputs[i].steer;
			str += int(Inputs[i].time*1000) + " Steer " + Inputs[i].steer + "\n";
		}

	}

	file.WriteLine(str);
	return;
}

